<template>
  <multiselect v-model="internalValue"
               :multiple="true"
               :close-on-select="false"
               :options="options"
               :taggable="true"
               :hide-selected="true"
               tag-position="bottom"
               @tag="addTag">
    <template #tag="props">
      <rui-tag :tag="props.option" removable @remove="removeTag" />
    </template>
    <template #option="props">
      <rui-tag :tag="props.option.length > 0 ? props.option : props.search" />
    </template>
  </multiselect>
</template>

<script>
import Multiselect from 'vue-multiselect'
import RuiTag from '../../DataDisplay/Tag/Tag.vue'

/**
 * Component used to select tags from a list
 *
 * @preset default { "props": { "modelValue": [], "tags": ["blue", "red", "green", "orange", "ugly::yes", "ugly::no"] } }
 *
 * @bindValue a tag
 * @disableProps modelValue
 */
export default {
  name: 'RuiTagSelector',
  emits: [
    'update:modelValue',
  ],
  components: { RuiTag, Multiselect },
  props: {
    /** Available tags list */
    tags: { required: false, type: Array, default: () => ([]) },
    modelValue: { required: true, type: Array },
  },
  data () {
    return {
      internalValue: this.$props.modelValue,
      options: this.$props.tags,
    }
  },
  methods: {
    addTag (tag) {
      this.options.push(tag)
      this.internalValue.push(tag)
    },
    removeTag (tag) {
      const index = this.internalValue.findIndex((t) => t === tag)
      if (index > -1) this.internalValue.splice(index, 1)
    },
  },
  watch: {
    modelValue (newValue) {
      if (this.internalValue.toString() !== newValue.toString()) this.internalValue = newValue
    },
    internalValue () {
      this.$emit('update:modelValue', this.internalValue)
    },
  },
}
</script>
